IF EXISTS (SELECT * FROM OrionExtensions
		   WHERE Name = 'VSEMAS870000')
BEGIN
	UPDATE EPOTaskSettings
	SET Value = 1
	WHERE SettingName = 'ApplyNVP'
	AND SectionName = 'Spyware'
	AND ParentID IN (SELECT AutoID
			 FROM EPOTask
			 WHERE ProductCode = 'VIRUSCAN8700')
END
GO


if exists (select * from tempdb..sysobjects where name like '#vsetasktime%')
drop table #vsetasktime
go

begin
-- Update the timestamps so that the agents know there are new tasks
declare @Currenttime int
select @Currenttime = @@dbts

update epotask set TheTimestamp = @Currenttime
where ProductCode = 'VIRUSCAN8700'

select parentid as autoid, parenttype, max(thetimestamp)as maxtime
into #vsetasktime
from epotask
where ProductCode = 'VIRUSCAN8700'
group by parentid, parenttype

update epoleafnode
set tasktimestamp = #vsetasktime.maxtime + 1
from #vsetasktime
where epoleafnode.autoid = #vsetasktime.autoid
and #vsetasktime.parenttype = epoleafnode.type

update epobranchnode
set tasktimestamp = #vsetasktime.maxtime + 1
from #vsetasktime
where epobranchnode.autoid = #vsetasktime.autoid
and #vsetasktime.parenttype = epobranchnode.type

update epotasksettings set TheTimestamp = @Currenttime
from epotask
where epotasksettings.parentid = epotask.autoid
and epotask.ProductCode = 'VIRUSCAN8700'

end
go

if exists (select * from tempdb..sysobjects where name like '#vsetasktime%')
drop table #vsetasktime
go